*-------------------------------------------------------------------------------
*      Program: CDEFAULT.PRG
*       Author: George E. McMullen
*             : Borland Technical Support
*         Date: 10-18-91
*     Function: Utilizes COLORCTL.BIN and CLRDESC.MEM (made from SETCLR.PRG)
*               to set saved color settings.
* Requirements: COLORCTL.BIN
*               CLRDESC.MEM (made from SETCLR.PRG)
*               VGA color monitor
*---
*-- Ken Mayer note: I changed COLOR.MEM  to  CLRDESC.MEM, since
*-- I already use COLOR.MEM for my memory variable to store the color
*-- memvars. CLRDESC stands for COLOR DESCRIPTION ...
*-------------------------------------------------------------------------------

*-- Setup Environment
gl_escape=IIF(SET("ESCAPE")="ON","ON","OFF")
SET ESCAPE OFF
gl_talk=IIF(SET("TALK")="ON","ON","OFF")
SET TALK OFF
gl_echo=IIF(SET("ECHO")="ON","ON","OFF")
SET ECHO OFF
CLEAR                                  && Clear screen

*-------------------------------------------------------------------------------
*--  Check for colorctl.bin and clrdesc.mem
*-------------------------------------------------------------------------------
IF .NOT. FILE("colorctl.bin") .OR. .NOT. FILE("clrdesc.mem")

  IF .NOT. FILE("colorctl.bin")        && Couldn't find COLORCTL.BIN
    ? CHR(7)+"Error: Could not locate COLORCTL.BIN"
  ENDIF

  IF .NOT. FILE("clrdesc.mem")          && Couldn't find CLRDESC.MEM
    ? CHR(7)+"Error: Could not locate CLRDESC.MEM - Run SETCLR.PRG first."
  ENDIF

  SET ESCAPE &gl_escape                && Reset environment
  SET ECHO &gl_echo
  SET TALK &gl_talk
  RETURN

ENDIF

*-------------------------------------------------------------------------------
*-- The files exist, load things up, and go ...
*-------------------------------------------------------------------------------
LOAD colorctl.bin                      && Load COLORCTL.BIN
RESTORE FROM clrdesc ADDITIVE          && Get saved colors (gl_color[16,4])
pv_index=1
pv_new_color=""                        && Set colorctl.bin command holder

*-- load the VGA Colors ...
DO WHILE pv_index<17
  pv_new_color='"Index='+STR(gl_colors[pv_index,1],2)+'",'+;
               '"Red='  +STR(gl_colors[pv_index,2],2)+'",'+;
               '"Green='+STR(gl_colors[pv_index,3],2)+'",'+;
               '"Blue=' +STR(gl_colors[pv_index,4],2)+'"'
  CALL colorctl WITH '/S',&pv_new_color  && Set new index color
  pv_index=pv_index+1
ENDDO

*-- cleanup
RELEASE module colorctl              && Release COLORCTL.BIN from memory
SET ESCAPE &gl_escape                && Reset environment
SET ECHO &gl_echo
SET TALK &gl_talk

RETURN

*-------------------------------------------------------------------------------
*-- End of Program: CDEFAULT.PRG
*-------------------------------------------------------------------------------
